'gbImageLab - test bed for image analysis
#Compile Exe
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production
#Include "Win32API.inc"
#Include "commctrl.inc"
#Resource "gbImageLab.pbr"

Type GdiplusStartupInput Dword
   GdiplusVersion           As Dword
   DebugEventCallback       As Dword
   SuppressBackgroundThread As Long
   SuppressExternalCodecs   As Long
End Type

Type GdiplusStartupOutput Dword
   NotificationHook   As Dword
   NotificationUnhook As Dword
End Type

Declare Function GdiplusStartup Lib "gdiplus.dll" Alias "GdiplusStartup" (ByRef token As Dword, ByRef Input As GdiplusStartupInput, ByRef Output As GdiplusStartupOutput) As Long
Declare Sub      GdiplusShutdown Lib "gdiplus.dll" Alias "GdiplusShutdown" (ByVal token As Dword)
Declare Function GdipGetImageWidth Lib "GDIPLUS.DLL" Alias "GdipGetImageWidth" (ByVal Image As Dword, ByRef Width As Dword) As Long
Declare Function GdipGetImageHeight Lib "GDIPLUS.DLL" Alias "GdipGetImageHeight" (ByVal Image As Dword, ByRef height As Dword) As Long
Declare Function GdipCreateFromHDC Lib "gdiplus.dll" Alias "GdipCreateFromHDC" (ByVal hdc As Dword, ByRef graphics As Dword) As Long
Declare Function GdipLoadImageFromFile Lib "gdiplus.dll" Alias "GdipLoadImageFromFile" (ByVal filename As Dword, ByRef Image As Dword) As Long
Declare Function GdipDrawImage Lib "gdiplus.dll" Alias "GdipDrawImage"(ByVal graphics As Dword, ByVal Image As Dword, ByVal x As Single, ByVal y As Single) As Long                                              ' GpStatus
Declare Function GdipDisposeImage Lib "gdiplus.dll" Alias "GdipDisposeImage" (ByVal Image As Dword) As Long
Declare Function GdipDeleteGraphics Lib "gdiplus.dll" Alias "GdipDeleteGraphics" (ByVal graphics As Dword) As Long
Declare Function GdipDrawImageRectI Lib "gdiplus.dll" Alias "GdipDrawImageRectI" (ByVal hGraphics???, ByVal nImage???, ByVal x&,ByVal y&, ByVal nWidth&, ByVal nHeight&) As Long

Declare Function Sub1( p1 As Any ) As Dword
Declare Function Sub2( p1 As Any, p2 As Any ) As Dword
Declare Function Sub3( p1 As Any, p2 As Any, p3 As Any ) As Dword
Declare Function Sub5( p1 As Any, p2 As Any, p3 As Any, p4 As Any, p5 As Any ) As Dword

%PixelData = 0
%CellData = 1
%PixelColor = 0
%CellColor = 1

Type CellDataType
    x1 As Long
    y1 As Long
    x2 As Long
    y2 As Long
    Ravg As Long
    Gavg As Long
    Bavg As Long
    Aavg As Long
    Color As Long
End Type

Type PixelDataType
    Color As Long
    R As Byte
    G As Byte
    B As Byte
    A As Byte
End Type

$Title = "  gbImageLab v1.01"

%IDC_Graphic         = 400
%IDC_ListView        = 401
%IDC_Toolbar         = 402
%IDC_StatusBar       = 403

%IDM_EffectGray      = 500
%IDM_EffectFlipV     = 501
%IDM_EffectFlipH     = 502
%IDM_EffectCopy      = 503
%IDM_EffectRestore   = 504
%IDM_EffectClear     = 505           'clear highlighting and selection
%IDM_EffectLoadFromClipboard = 506
%IDM_EffectClearConsole      = 507

%IDM_Histogram       = 550
%IDM_ROI             = 551
%IDM_CustomAnalysis  = 552
%IDM_ZeroAlpha       = 553
%IDM_ResizeImage     = 554
%IDM_Sep             = 555
%IDM_Debug           = 556
%IDM_ColorFinder     = 557
%IDM_AutoScroll      = 558
%IDM_ThinGrid        = 559
%IDM_HexDisplay      = 560

%IDM_History1   = 601
%IDM_History2   = 602
%IDM_History3   = 603
%IDM_History4   = 604
%IDM_History5   = 605

%IDM_Size5      = 650
%IDM_Size10     = 651
%IDM_Size25     = 652
%IDM_Size50     = 653
%IDM_Size100    = 654
%IDM_Size250    = 655
%IDM_SizeCustom = 656

%IDT_Open     = 700
%IDT_Pixel    = 701
%IDT_Color    = 702
%IDT_Image    = 703
%IDT_Cell     = 704
%IDT_Help     = 705
%IDT_Grid     = 706
%IDT_CellSize = 707
%IDT_Settings = 708
%IDT_Analyze  = 709
%IDT_Save     = 710
%IDT_Actions  = 711
%IDT_Zoom     = 712

Global hDlg,hBMP,hContext,hToolbar,hImageList,hTooltip,hListView,hZoom,hHistogram,hHook As Dword, bmp$
Global hPopupAnalyze,hPopupSettings,hPopupActions,hPopupSize,hPopupHistory,hConsole,hGraphic As Dword
Global CellSizeX, CellSizeY, XCellCount, YCellCount, DrawInWork, PreventContext As Long
Global CellData() As CellDataType, CFN As String
Global PixelData() As PixelDataType
Global imgW,imgH, DataType, ColorType, CustomXCellSize, CustomYCellSize As Long
Global Grid, ZeroAlpha, ResizeImage, Debug, AutoScroll, ColorFinder, ThinGrid, HexDisplay As Long
Global History1, History2, History3, History4, History5 As String
Global gR, gR2, gRect As Rect, OldProc&

Function PBMain() As Long
   Dialog New Pixels, 0, $Title,500,300,500,200, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "aaa"
   Control Add Graphic, hDlg, %IDC_Graphic, "", 520,60,100,100, %SS_Notify
   gRect.nLeft = 520 : gRect.nTop = 60 : gRect.nRight = 620 : gRect.nBottom = 160
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Control Add ListView, hDlg, %IDC_ListView,"", 10, 60, 500,180, %LBS_Notify + %WS_TabStop + %WS_VScroll + %LBS_NoIntegralHeight + %LVS_SingleSel + %LVS_ShowSelAlways + %LVS_OwnerData, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
   CreateToolbar : CreateDropDownMenus : SetToolbarButtonStatus
   DragAcceptFiles hDlg, %True
   Control Add Statusbar, hDlg, %IDC_StatusBar,"", 0,0,0,0, %CCS_Bottom + %SBars_SizeGrip
   Statusbar Set Parts hDlg, %IDC_StatusBar,150,100,125,150,99999
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local x,y,iColor As Long, nmtb As TBNOTIFY Ptr, rc As RECT
   Local P As ToolTipText Ptr, temp$, tempW$$, mpt, pt As Point, pLVDI As LV_DISPINFO Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
          Settings_INI "get"
          OldProc& = SetWindowLong(hGraphic, %GWL_WndProc, CodePtr(NewProc))  'subclass
          LoadNewFile
'      Case %WM_ContextMenu
'         If JustErased = 0 Then
'            x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
'            TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, Cb.Hndl, ByVal 0
'         End If
      Case %WM_Size
          Dialog Get Client hDlg To x,y
          Control Set Size hDlg, %IDC_ListView,500,y-90

'      Case %WM_SetCursor
'         GetCursorPos mpt               'pt has xy screen coordinates
'         ScreenToClient hDlg, mpt       'pt now has dialog client coordinates
'         If PtInRect(gRect,mpt) Then
'            Dialog Set Text hDlg, "SetCursor: " + Str$(mpt.x-gRect.nLeft) + ":" + Str$(mpt.y-gRect.nTop)
'         End if

      Case %WM_Command
          Select Case Cb.Ctl
'              Case %IDC_Graphic
'                  If Cb.CtlMsg = %STN_Clicked Then
'                      If AutoScroll Then HighlightListView
'                      GetCursorPos pt    'p.x and p.y are in screen coordinates
'                      ScreenToClient hGraphic, pt  'p.x and p.y are now graphic client coordinates
'                      If ColorType = %PixelColor Then
'                         Graphic Get Pixel (pt.x,pt.y) To iColor
'                         Statusbar Set Text hDlg, %IDC_StatusBar, 4, 0, " Pixel:  " + Str$(pt.x) + "x" + Trim$(Str$(pt.y)) + "  " + Str$(iColor)
'                      Else
'                        Statusbar Set Text hDlg, %IDC_StatusBar, 4, 0, " Cell:  " + Str$(pt.x) + "x" + Trim$(Str$(pt.y))
'                      End If
'                  End If
              Case %IDT_Open         : SelectCFN               : LoadNewFile
              Case %IDT_Save         : SaveFileAs
              Case %IDT_Pixel        : DataType = %PixelData   : DisplayHeaders : SetListViewRowCount : SetStatusBarText
              Case %IDT_Color        : DataType = %CellData    : DisplayHeaders : SetListViewRowCount : SetStatusBarText
              Case %IDT_Image        : ColorType = %PixelColor : DisplayImage
              Case %IDT_Cell         : ColorType = %CellColor  : DisplayImage
              Case %IDT_Grid         : Grid = Grid Xor 1       : DisplayImage
              Case %IDT_Zoom         : Zoom
              Case %IDT_Help         : OpenWebPage

              Case %IDT_CellSize     : CycleCellSize
              Case %IDM_Size5        : ChangeCellSize(5,5)
              Case %IDM_Size10       : ChangeCellSize(10,10)
              Case %IDM_Size25       : ChangeCellSize(25,25)
              Case %IDM_Size50       : ChangeCellSize(50,50)
              Case %IDM_Size100      : ChangeCellSize(100,100)
              Case %IDM_Size250      : ChangeCellSize(250,250)
              Case %IDM_SizeCustom   : SetCustomCellSize  : SetMenus

              Case %IDT_Settings     : ShowConsole
              Case %IDT_Actions      : ClearConsole
              Case %IDM_ColorFinder  : ColorFinder = ColorFinder Xor 1 : SetMenus
              Case %IDM_ThinGrid     : ThinGrid = ThinGrid Xor 1       : SetMenus : DisplayImage
              Case %IDM_HexDisplay   : HexDisplay = HexDisplay Xor 1   : SetMenus : DisplayImage
              Case %IDM_AutoScroll   : AutoScroll = AutoScroll Xor 1   : SetMenus
              Case %IDM_ZeroAlpha    : ZeroAlpha = ZeroAlpha Xor 1     : SetMenus
              Case %IDM_ResizeImage  : ResizeImage = ResizeImage Xor 1 : SetMenus

              Case %IDM_EffectGray              : ConvertToGray
              Case %IDM_EffectFlipV             : FlipVertical
              Case %IDM_EffectFlipH             : FlipHorizontal
              Case %IDM_EffectCopy              : CopyToClipboard
              Case %IDM_EffectRestore
                  Restore
                  Reset gR, gR2
                  If DrawInWork Then DrawRect 0

              Case %IDM_EffectLoadFromClipboard : LoadFromClipboard
              Case %IDM_EffectClearConsole      : ClearConsole

              Case %IDM_EffectClear
                  ClearHighlighting
                  Reset gR,gR2
                  If DrawInWork Then DrawRect 0

              Case %IDM_Debug                   : ShowConsole

              Case %IDT_Analyze         : Histogram
              Case %IDM_Histogram       : Histogram
              Case %IDM_ROI             : ROI
              Case %IDM_CustomAnalysis
                  'MsgBox "Not implemented!", %MB_Ok + %MB_IconInformation, "Custom Analysis"
                  hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  MessageBox 0, "Not implemented!", "Custom Analysis", %MB_IconInformation Or %MB_Ok Or %MB_TaskModal


              Case %IDM_History1 : CFN = History1 : LoadNewFile
              Case %IDM_History2 : CFN = History2 : LoadNewFile
              Case %IDM_History3 : CFN = History3 : LoadNewFile
              Case %IDM_History4 : CFN = History4 : LoadNewFile
              Case %IDM_History5 : CFN = History5 : LoadNewFile
          End Select
      Case %WM_Notify
          Select Case Cb.NmId
              Case %IDT_Open To %IDT_Zoom   'must be contiguous
                  Select Case Cb.NmCode
                      Case %TTN_GetDispInfo
                          P = Cb.LParam
                          @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
              Case %IDC_Toolbar
                  Select Case Cb.NmCode
                      Case %TBN_DropDown
                         nmtb = Cb.LParam
                         Select Case @nmtb.iItem
                            Case %IDT_Open
                               Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               Call TrackPopupMenu (hPopUpHistory, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                            Case %IDT_CellSize
                               Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               Call TrackPopupMenu (hPopUpSize, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                            Case %IDT_Analyze
                               Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               Call TrackPopupMenu (hPopUpAnalyze, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                            Case %IDT_Settings
                               Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                            Case %IDT_Actions
                               Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               Call TrackPopupMenu (hPopUpActions, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                        End Select
                  End Select
              Case %IDC_ListView
                  Select Case Cb.NmCode
                      Case %NM_DblClk
                          If ColorFinder Then HighlightImage
                      Case %LVN_GetDispInfoW
'                           If Debug Then cprint "lvn_getdispinfo"   '<---- commented out by decision to limit ListView lines
                           pLVDI = Cb.LParam               'pointer to LVDISPINFO structure for requested subitem
                           x = @pLVDI.item.iItem           'row being asked for
                           y = @pLVDI.item.iSubItem        'sub item being asked for (columns)
                           tempW$$ = GetListViewData(x,y)
                           @pLVDI.item.pszText = StrPtr(tempW$$) 'text sent to ListView
                      Case %TTN_GetDispInfo
                            P = Cb.LParam
                            @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
          End Select
      Case %WM_Destroy
          Settings_INI "save"
          SetWindowLong hGraphic, %GWL_WNDPROC, OldProc&   'un-subclass

      Case %WM_DropFiles
          temp$ = GetDroppedFileName(Cb.WParam)
          DragFinish Cb.WParam
          If LCase$(Right$(temp$,4)) = ".lnk" Then temp$ = GetLinkInfo(temp$)
          If IsFile(temp$) Then
              Select Case LCase$(Right$(temp$,4))
                  Case ".jpg", ".bmp", ".png", ".gif"  : CFN = LCase$(temp$) : LoadNewFile
                  Case Else
                      'MsgBox "Wrong file type!", %MB_Ok+%MB_IconExclamation, "Open File"
                      hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                      MessageBox 0, "Wrong file type!", "Open File", %MB_IconExclamation Or %MB_Ok Or %MB_TaskModal
              End Select
          Else
              'MsgBox "Invalid File!", %MB_Ok+%MB_IconExclamation, "Open File"
              hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
              MessageBox 0, "Invalid File!", "Open File", %MB_IconExclamation Or %MB_Ok Or %MB_TaskModal
          End If
   End Select
End Function

Function GetListViewData(x As Long, iCol As Long) As String
    'If Debug Then cPrint LCase$(FuncName$)    '<----- commented out by decision to limit # console lines
    Local y As Long
    If DataType = %PixelData Then
        y = x \ imgW
        x = x Mod imgW
        Select Case iCol
            Case 0 : Function = Str$(x)
            Case 1 : Function = Str$(y)
            Case 2 : Function = Str$(PixelData(x,y).Color)
            Case 3 : Function = Str$(PixelData(x,y).R)
            Case 4 : Function = Str$(PixelData(x,y).G)
            Case 5 : Function = Str$(PixelData(x,y).B)
            Case 6 : Function = Str$(PixelData(x,y).A)
        End Select
    Else
        y = x \ XCellCount
        x = x Mod XCellCount
        Select Case iCol
            Case 0 : Function = Str$(x)
            Case 1 : Function = Str$(y)
            Case 2 : Function = Str$(CellData(x,y).Color)
            Case 3 : Function = Str$(CellData(x,y).Ravg)
            Case 4 : Function = Str$(CellData(x,y).Gavg)
            Case 5 : Function = Str$(CellData(x,y).Bavg)
            Case 6 : Function = Str$(CellData(x,y).x1)
            Case 7 : Function = Str$(CellData(x,y).y1)
            Case 8 : Function = Str$(CellData(x,y).x2)
            Case 9 : Function = Str$(CellData(x,y).y2)
        End Select
    End If
End Function

Sub MakeGrid
   If Debug Then cPrint LCase$(FuncName$)
   Local i,w,h As Long
   If Grid = 0 Then Exit Sub
   Control Get Client hDlg, %IDC_Graphic To w,h
   If ThinGrid Then
       For i = -1 To w Step CellSizeX
          Graphic Line (i,0)-(i,h-1), %Black
       Next i
       For i = -1 To h Step CellSizeY
          Graphic Line (0,i)-(w-1,i), %Black
       Next i
   Else
       For i = 0 To w Step CellSizeX
          Graphic Line (i,0)-(i,h-1), %Black
          Graphic Line (i+CellSizeX-1,0)-(i+CellSizeX-1,h-1), %Black
       Next i
       For i = 0 To h Step CellSizeY
          Graphic Line (0,i)-(w-1,i), %Black
          Graphic Line (0,i+CellSizeY-1)-(w-1,i+CellSizeY-1), %Black
       Next i
   End If
End Sub

Sub DisplayCellColors
   If Debug Then cPrint LCase$(FuncName$)
   Local x,y As Long
   For y = 0 To YCellCount-1
      For x = 0 To XCellCount-1
           Graphic Box (CellData(x,y).x1,CellData(x,y).y1)-(CellData(x,y).x2,CellData(x,y).y2),,CellData(x,y).Color,CellData(x,y).Color
      Next x
   Next y
End Sub

Sub LoadCFN
   If Debug Then cPrint LCase$(FuncName$)
   On Error GoTo LoadError

   Local pGraphics, pImage, hBMPDC As Dword, strFileName As String
   Local token As Dword, StartupInput As GdiplusStartupInput

   'initialize GDIPlus
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   'load/display image onto Graphic control
   strFileName = UCode$(CFN)                         'image source file
   GdipLoadImageFromFile(StrPtr(strFileName), pImage)  'pImage - image object
   GdipGetImageWidth(pImage,ImgW)
   GdipGetImageHeight(pImage,ImgH)

   'place to put the image
   Graphic Bitmap End
   Graphic Bitmap New ImgW,ImgH To hBMP
   Graphic Attach hBMP, 0
   Graphic Get DC To hBMPDC

   GdipCreateFromHDC(hBMPDC, pGraphics)                    'pGraphics - graphic object
   GdipDrawImageRectI pGraphics, pImage, 0, 0, ImgW, ImgH  'draw on graphic object - hBMP now contains image from file

   'cleanup
   If pImage Then GdipDisposeImage(pImage)         'delete image object
   If pGraphics Then GdipDeleteGraphics(pGraphics) 'delete graphic object
   GdiplusShutdown token                           ' Shutdown GDI+

   Exit Sub
LoadError:
   'MsgBox "Error: " + Str$(Err) + $CrLf + Error$(Err), %MB_Ok + %MB_IconExclamation, "Load Error"
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   MessageBox 0, "Error: " + Str$(Err) + $CrLf + Error$(Err), "Load Error", %MB_IconExclamation Or %MB_Ok Or %MB_TaskModal
End Sub

Sub ZeroAlphaData
   If Debug Then cPrint LCase$(FuncName$)
   Local bp As Byte Pointer, i As Long
   'get bit string, zero out the alpha values
   Graphic Get Bits To bmp$
   bp = StrPtr(bmp$) + 11
   For i = 1 To imgW*imgH
      @bp = 0                 'set 4th byte to zero
      bp = bp + 4             'next 4th byte
   Next i
   Graphic Set Bits bmp$
End Sub

Sub CreatePixelData
   If Debug Then cPrint LCase$(FuncName$)
   Local bp As Byte Pointer, i,R,G,B,A,x,y As Long
   'save color/r/g/b/a data into PixelData() array
   ReDim PixelData(imgW-1,imgH-1)  'PixelData() stores color,R,G,B,A
   bp = StrPtr(bmp$)+8             'position of starting position for bits in string
   For i = 0 To ImgW*ImgH - 1
      B = @bp : Incr bp
      G = @bp : Incr bp
      R = @bp : Incr bp
      A = @bp : Incr bp
      x = i Mod imgW
      y = i \ imgW
      PixelData(x,y).Color = RGB(R,G,B)
      PixelData(x,y).R = R
      PixelData(x,y).G = G
      PixelData(x,y).B = B
      PixelData(x,y).A = A
   Next i
End Sub

Sub SetListviewColumns(Flag As Long)
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    For i = 10 To 1 Step -1 : ListView Delete Column hDlg, %IDC_ListView, i : Next i
    If Flag = %PixelData Then
      'columns               hdlg, id&, col, "test", width, format
      ListView Insert Column hDlg, %IDC_ListView, 1, "x", 65, 0
      ListView Insert Column hDlg, %IDC_ListView, 2, "y", 65, 0
      ListView Insert Column hDlg, %IDC_ListView, 3, "Color", 90, 0
      ListView Insert Column hDlg, %IDC_ListView, 4, "R", 65, 0
      ListView Insert Column hDlg, %IDC_ListView, 5, "G", 65, 0
      ListView Insert Column hDlg, %IDC_ListView, 6, "B", 65, 0
      ListView Insert Column hDlg, %IDC_ListView, 7, "A", 65, 0
    Else
      'columns               hdlg, id&, col, "test", width, format
      ListView Insert Column hDlg, %IDC_ListView, 1, "x", 45, 0
      ListView Insert Column hDlg, %IDC_ListView, 2, "y", 45, 0
      ListView Insert Column hDlg, %IDC_ListView, 3, "Color", 70, 0
      ListView Insert Column hDlg, %IDC_ListView, 4, "R", 45, 0
      ListView Insert Column hDlg, %IDC_ListView, 5, "G", 45, 0
      ListView Insert Column hDlg, %IDC_ListView, 6, "B", 45, 0
      ListView Insert Column hDlg, %IDC_ListView, 7, "x1", 45, 0
      ListView Insert Column hDlg, %IDC_ListView, 8, "y1", 45, 0
      ListView Insert Column hDlg, %IDC_ListView, 9, "x2", 45, 0
      ListView Insert Column hDlg, %IDC_ListView, 10, "y2", 45, 0
    End If
End Sub

Sub CreateCellData   'load CellData()
    If Debug Then cPrint LCase$(FuncName$)
    Local i,j,x,y,TrueCellSizeX,TrueCellSizeY As Long

    XCellCount = imgW \ CellSizeX + IIf(imgW Mod CellSizeY, 1, 0)
    YCellCount = imgH \ CellSizeY + IIf(imgH Mod CellSizeY, 1, 0)

    ReDim CellData(XCellCount-1, YCellCount-1)
    For y = 0 To YCellCount-1
        For x = 0 To XCellCount-1
            'cell boundaries
            CellData(x,y).x1 = x * CellSizeX
            CellData(x,y).x2 = CellData(x,y).x1 + CellSizeX -1
            If CellData(x,y).x2 > imgW Then CellData(x,y).x2 = imgW - 1  'right column may not be full size in x direction
            CellData(x,y).y1 = y * CellSizeY
            CellData(x,y).y2 = CellData(x,y).y1 + CellSizeY -1
            If CellData(x,y).y2 > imgH Then CellData(x,y).y2 = imgH - 1  'bottom row cell may not be full size in y direction
            'cell average RGB
            For i = CellData(x,y).x1 To CellData(x,y).x2
                For j = CellData(x,y).y1 To CellData(x,y).y2
                   CellData(x,y).Ravg = CellData(x,y).Ravg + PixelData(i,j).R
                   CellData(x,y).Gavg = CellData(x,y).Gavg + PixelData(i,j).G
                   CellData(x,y).Bavg = CellData(x,y).Bavg + PixelData(i,j).B
                Next j
            Next i
            TrueCellSizeX = CellData(x,y).x2 - CellData(x,y).x1 + 1
            TrueCellSizeY = CellData(x,y).y2 - CellData(x,y).y1 + 1
            CellData(x,y).Ravg = CellData(x,y).Ravg / (TrueCellSizeX * TrueCellSizeY)
            CellData(x,y).Gavg = CellData(x,y).Gavg / (TrueCellSizeX * TrueCellSizeY)
            CellData(x,y).Bavg = CellData(x,y).Bavg / (TrueCellSizeX * TrueCellSizeY)
            CellData(x,y).Color = RGB(CellData(x,y).Ravg, CellData(x,y).Gavg, CellData(x,y).Bavg)
        Next x
    Next y
End Sub

Sub SelectCFN
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   title$ = "Open File"
   filter$ = "Images" + $Nul + "*.bmp;*.jpg;*.gif;*.png" + $Nul
   startfolder$ = CFN
   startfile$ = CFN
   defaultext$ = ""
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then CFN = LCase$(filevar$)
End Sub

Sub Settings_INI(Task$)
   If Debug Then cPrint LCase$(FuncName$)
   Local x,y As Long, xResult, yResult, tempz, INIFileName As AsciiZ*%Max_Path

   'defines INI file name
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      GetPrivateProfileString "All", "Left", "300", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "950", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "450", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for string variables
      GetPrivateProfileString "All", "CFN", Exe.Path$ + "images\cowboy.bmp", tempz, %Max_Path, INIFileName  : CFN = LCase$(tempz)
      GetPrivateProfileString "All", "History1", "", tempz, %Max_Path, INIFileName  : History1 = tempz
      GetPrivateProfileString "All", "History2", "", tempz, %Max_Path, INIFileName  : History2 = tempz
      GetPrivateProfileString "All", "History3", "", tempz, %Max_Path, INIFileName  : History3 = tempz
      GetPrivateProfileString "All", "History4", "", tempz, %Max_Path, INIFileName  : History4 = tempz
      GetPrivateProfileString "All", "History5", "", tempz, %Max_Path, INIFileName  : History5 = tempz
      'get value for numeric variable
      GetPrivateProfileString "All", "CellSizeX", "25", tempz, %Max_Path, INIFileName              : CellSizeX = Val(tempz)
      GetPrivateProfileString "All", "CellSizeY", "25", tempz, %Max_Path, INIFileName              : CellSizeY = Val(tempz)
      GetPrivateProfileString "All", "Grid", "1", tempz, %Max_Path, INIFileName                    : Grid = Val(tempz)
      GetPrivateProfileString "All", "DataType", Str$(%PixelData), tempz, %Max_Path, INIFileName   : DataType = Val(tempz)
      GetPrivateProfileString "All", "ColorType", Str$(%PixelColor), tempz, %Max_Path, INIFileName : ColorType = Val(tempz)
      GetPrivateProfileString "All", "ZeroAlpha", "1", tempz, %Max_Path, INIFileName               : ZeroAlpha = Val(tempz)
      GetPrivateProfileString "All", "ResizeImage", "0", tempz, %Max_Path, INIFileName             : ResizeImage = Val(tempz)
      GetPrivateProfileString "All", "AutoScroll", "1", tempz, %Max_Path, INIFileName              : AutoScroll = Val(tempz)
      GetPrivateProfileString "All", "ColorFinder", "0", tempz, %Max_Path, INIFileName             : ColorFinder = Val(tempz)
      GetPrivateProfileString "All", "ThinGrid", "1", tempz, %Max_Path, INIFileName                : ThinGrid = Val(tempz)
      GetPrivateProfileString "All", "HexDisplay", "1", tempz, %Max_Path, INIFileName              : HexDisplay = Val(tempz)
      GetPrivateProfileString "All", "CustomXCellSize", "25", tempz, %Max_Path, INIFileName        : CustomXCellSize = Val(tempz)
      GetPrivateProfileString "All", "CustomYCellSize", "50", tempz, %Max_Path, INIFileName        : CustomYCellSize = Val(tempz)
      GetPrivateProfileString "All", "Debug", "0", tempz, %Max_Path, INIFileName                   : Debug = Val(tempz)

   ElseIf Task$ = "save" Then
      If IsFile(INIFileName) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "CFN", (CFN), INIFileName
      WritePrivateProfileString "All", "History1", (History1), INIFileName
      WritePrivateProfileString "All", "History2", (History2), INIFileName
      WritePrivateProfileString "All", "History3", (History3), INIFileName
      WritePrivateProfileString "All", "History4", (History4), INIFileName
      WritePrivateProfileString "All", "History5", (History5), INIFileName
      'save numeric variable
      WritePrivateProfileString "All", "CellSizeX", (Str$(CellSizeX)), INIFileName
      WritePrivateProfileString "All", "CellSizeY", (Str$(CellSizeY)), INIFileName
      WritePrivateProfileString "All", "Grid", (Str$(Grid)), INIFileName
      WritePrivateProfileString "All", "DataType", (Str$(DataType)), INIFileName
      WritePrivateProfileString "All", "ColorType", (Str$(ColorType)), INIFileName
      WritePrivateProfileString "All", "ZeroAlpha", (Str$(ZeroAlpha)), INIFileName
      WritePrivateProfileString "All", "ResizeImage", (Str$(ResizeImage)), INIFileName
      WritePrivateProfileString "All", "AutoScroll", (Str$(AutoScroll)), INIFileName
      WritePrivateProfileString "All", "ColorFinder", (Str$(ColorFinder)), INIFileName
      WritePrivateProfileString "All", "ThinGrid", (Str$(ThinGrid)), INIFileName
      WritePrivateProfileString "All", "HexDisplay", (Str$(HexDisplay)), INIFileName
      WritePrivateProfileString "All", "CustomXCellSize", (Str$(CustomXCellSize)), INIFileName
      WritePrivateProfileString "All", "CustomYCellSize", (Str$(CustomYCellSize)), INIFileName
      WritePrivateProfileString "All", "Debug", (Str$(Debug)), INIFileName
   End If
End Sub

Sub CreateToolbar
    If Debug Then cPrint LCase$(FuncName$)
    Local hTips As Dword
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Border Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    hTips = SendMessage(GetDlgItem(hDlg, %IDC_Toolbar), %TB_GETTOOLTIPS, 0, 0)
    SetWindowLong hTips, %GWL_STYLE, GetWindowLong(hTips, %GWL_STYLE) Or %TTS_ALWAYSTIP

    'imagelist
    ImageList New Icon 24,24,32,50 To hImageList
    ImageList Add Icon hImageList, "open"          '1
    ImageList Add Icon hImageList, "help"          '2
    ImageList Add Icon hImageList, "pixels"        '3
    ImageList Add Icon hImageList, "cells"         '4
    ImageList Add Icon hImageList, "image"         '5
    ImageList Add Icon hImageList, "grid"          '6
    ImageList Add Icon hImageList, "size"          '7
    ImageList Add Icon hImageList, "celldata"      '8
    ImageList Add Icon hImageList, "settings"      '9
    ImageList Add Icon hImageList, "analyze"       '10
    ImageList Add Icon hImageList, "save"          '11
    ImageList Add Icon hImageList, "actions"       '12
    ImageList Add Icon hImageList, "zoom"          '13

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0    'attach imagelist

    If 1 Then
        'Real/Final
        Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Open,   %TbStyle_Button Or %TbStyle_DropDown, "Open"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Save,   %TbStyle_Button, "Save As"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Pixel,  %TbStyle_Check Or %TbStyle_Group, "Pixel Data"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Color,  %TbStyle_Check Or %TbStyle_Group, "Cell Data"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Image,  %TbStyle_Check Or %TbStyle_Group, "Pixels"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Cell,   %TbStyle_Check Or %TbStyle_Group, "Cells"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Analyze,   %TbStyle_Button Or %TbStyle_DropDown, "Analyze"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Actions, %TbStyle_DropDown, "Actions"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Zoom,   %TbStyle_Button, "Zoom"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Grid,   %TbStyle_Check, "Grid"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_CellSize, %TbStyle_Button Or %TbStyle_DropDown, "Cell Size"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Settings, %TbStyle_DropDown, "Settings"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Help,   %TbStyle_Button, "Help"
    Else
        'Fake/for picture taking
        Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Open,   %TbStyle_Button Or %TbStyle_DropDown, "Open"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Save,   %TbStyle_Button, "Save As"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Pixel,  %TbStyle_Check , "Pixel Data"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Color,  %TbStyle_Check , "Cell Data"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Image,  %TbStyle_Check , "Pixels"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Cell,   %TbStyle_Check , "Cells"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Analyze,   %TbStyle_Button Or %TbStyle_DropDown, "Analyze"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Actions, %TbStyle_DropDown, "Actions"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Zoom,   %TbStyle_Button, "Zoom"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Grid,   %TbStyle_Check, "Grid"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_CellSize, %TbStyle_Button Or %TbStyle_DropDown, "Cell Size"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Settings, %TbStyle_DropDown, "Settings"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Help,   %TbStyle_Button, "Help"
    End If
End Sub

Function SetToolTips(cID As Long) As String
'  If Debug Then cPrint LCase$(FuncName$)            '<----- commented out by decision to limit # console lines
  Select Case cID           'or this:   @P.hdr.idFrom
    Case %IDT_Open          : Function = "Open Image"
    Case %IDT_Pixel         : Function = "Show Pixel Data"
    Case %IDT_Color         : Function = "Show Cell Colors"
    Case %IDT_Image         : Function = "Show Image"
    Case %IDT_Cell          : Function = "Open Image"
    Case %IDT_Grid          : Function = "Show Grid"
    Case %IDT_Help          : Function = "Online Help"
    Case %IDT_Analyze       : Function = "Analyze Image"
    Case %IDT_Save          : Function = "Save As"
    Case %IDT_CellSize      : Function = "Select Cell Size"
    Case %IDT_Settings      : Function = "Application Settings"
    Case %IDT_Actions       : Function = "Take Action"
  End Select
End Function

Sub SetToolbarButtonStatus
   If Debug Then cPrint LCase$(FuncName$)
   If DataType = %PixelData Then
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Pixel, %TBState_Checked Or %TBState_Enabled
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Color, %TBState_Enabled
   Else
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Pixel, %TBState_Enabled
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Color, %TBState_Checked Or %TBState_Enabled
   End If

   If ColorType = %PixelColor Then
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Image, %TBState_Checked Or %TBState_Enabled
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Cell, %TBState_Enabled
   Else
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Image, %TBState_Enabled
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Cell, %TBState_Checked Or %TBState_Enabled
   End If

   If Grid Then
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Grid, %TBState_Checked Or %TBState_Enabled
   Else
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Grid, %TBState_Enabled
   End If
End Sub

Sub OpenWebPage
   If Debug Then cPrint LCase$(FuncName$)
   Local tempAsciiz As AsciiZ * %Max_Path, iReturn As Long
   tempAsciiZ = "http://www.garybeene.com/sw/gbimagelab.htm"
   iReturn = ShellExecute(hDlg, "Open", tempAsciiZ, $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub CreateDropDownMenus
  If Debug Then cPrint LCase$(FuncName$)
  Menu New PopUp To hPopupHistory

  Menu New PopUp To hPopupAnalyze
  Menu Add String, hPopupAnalyze, "Histogram", %IDM_Histogram, %MF_Enabled
  Menu Add String, hPopupAnalyze, "Region of Interest", %IDM_ROI, %MF_Enabled
  Menu Add String, hPopupAnalyze, "Custom Analysis", %IDM_CustomAnalysis, %MF_Enabled

  Menu New PopUp To hPopupActions
  Menu Add String, hPopupActions, "Convert to Gray Scale", %IDM_EffectGray, %MF_Enabled
  Menu Add String, hPopupActions, "Flip Vertically", %IDM_EffectFlipV, %MF_Enabled
  Menu Add String, hPopupActions, "Flip Horizontally", %IDM_EffectFlipH, %MF_Enabled
  Menu Add String, hPopupActions, "Copy", %IDM_EffectCopy, %MF_Enabled
  Menu Add String, hPopupActions, "-", %IDM_Sep, 0
  Menu Add String, hPopupActions, "Clear Console", %IDM_EffectClearConsole, %MF_Enabled

  Menu New PopUp To hPopupSettings
'  Menu Add String, hPopupSettings, "Zero Alpha On Load", %IDM_ZeroAlpha, %MF_Enabled
'  Menu Add String, hPopupSettings, "ReSize Image on Load", %IDM_ResizeImage, %MF_Enabled
'  Menu Add String, hPopupSettings, "-", %IDM_Sep, 0
  Menu Add String, hPopupSettings, "Color Finder", %IDM_ColorFinder, %MF_Enabled
  Menu Add String, hPopupSettings, "AutoScroll", %IDM_AutoScroll, %MF_Enabled
  Menu Add String, hPopupSettings, "-", %IDM_Sep, 0
  Menu Add String, hPopupSettings, "Thin Grid", %IDM_ThinGrid, %MF_Enabled
  Menu Add String, hPopupSettings, "Hex Color Display", %IDM_HexDisplay, %MF_Enabled
  Menu Add String, hPopupSettings, "-", %IDM_Sep, 0
  Menu Add String, hPopupSettings, "Console", %IDM_Debug, %MF_Enabled

  Menu New PopUp To hPopupSize
  Menu Add String, hPopupSize, "5x5", %IDM_Size5, %MF_Enabled
  Menu Add String, hPopupSize, "10x10", %IDM_Size10, %MF_Enabled
  Menu Add String, hPopupSize, "25x25", %IDM_Size25, %MF_Enabled
  Menu Add String, hPopupSize, "50x50", %IDM_Size50, %MF_Enabled
  Menu Add String, hPopupSize, "100x100", %IDM_Size100, %MF_Enabled
  Menu Add String, hPopupSize, "250x250", %IDM_Size250, %MF_Enabled
  Menu Add String, hPopupSize, "Custom", %IDM_SizeCustom, %MF_Enabled

   Menu New PopUp To hContext
   Menu Add String, hContext, "Clear Selection/Highlighting", %IDM_EffectClear, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, 0
   Menu Add String, hContext, "Copy Image/Selection", %IDM_EffectCopy, %MF_Enabled
   Menu Add String, hContext, "Restore", %IDM_EffectRestore, %MF_Enabled
   Menu Add String, hContext, "Load Clipboard Image", %IDM_EffectLoadFromClipboard, %MF_Enabled

End Sub

Sub SaveFileAs
    If Debug Then cPrint LCase$(FuncName$)
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, iResult&, tmp$
    title$ = ""                      'caption title. if "", then "Save As" is displayed
    startfolder$ = CFN               'initial folder to be displayed
    filter$ = "*.bmp" + $Nul
    startfile$ = PathName$(Path, CFN) + PathName$(Name, CFN) + ".bmp"        'name to be used as initial selection
    defaultext$ = ""               'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
        filevar$ = LCase$(filevar$)
        tmp$ = PathName$(Path, filevar$) + PathName$(Name, filevar$) + ".bmp"
        Local temp$
        temp$ = "Content will be saved to: " + $CrLf + tmp$ + $CrLf + $CrLf + "Are you sure?"
'        If MsgBox (temp$, %MB_OkCancel Or %MB_IconQuestion, "Save File") = %IdOk Then  Graphic Save CFN
        hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
        If MessageBox(0, (temp$), "Save File", %MB_IconQuestion Or %MB_OkCancel Or %MB_TaskModal) Then
            CFN = tmp$
            SetStatusBarText
            Graphic Save CFN
        End If
    End If
End Sub

Sub SetStatusBarText
    If Debug Then cPrint LCase$(FuncName$)
    Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, " Image Size:  " + Str$(imgW) + "x" + Trim$(Str$(imgH))
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Cells:  " + Str$(XCellCount) + "x" + Trim$(Str$(YCellCount))
    Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, " Cell Size:  " + Str$(CellSizeX) + "x" + Trim$(Str$(CellSizeY))
    Statusbar Set Text hDlg, %IDC_StatusBar, 5, 0, " " + CFN
End Sub

Function GetDroppedFileName(hDrop As Dword) As String
   If Debug Then cPrint LCase$(FuncName$)
   'David Gwillim July 2005
   Local fString As AsciiZ*%Max_Path, Count As Long
   fString=Space$(%Max_Path)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                           ' put Count chars into result string
End Function

Function GetLinkInfo(LinkPath As String ) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local CLSID_ShellLink, IID_IShellLink As GUIDAPI
   Local CLSCTX_INPROC_SERVER, Flags, lResult As Dword
   Local FileData As WIN32_FIND_DATA
   Local IID_Persist As String * 16, pp, ppf, psl As Dword Ptr
   Local outvalue, TmpAsciiz As AsciiZ * %Max_Path
   Local TmpWide As AsciiZ * ( 2 * %Max_Path )
   Poke$ VarPtr(CLSID_ShellLink), Mkl$( &H00021401 ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   Poke$ VarPtr(IID_IShellLink), Mkl$( &H000214EE ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   IID_Persist = Mkl$( &H0000010B ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   CLSCTX_INPROC_SERVER = 1
   If IsFalse( CoCreateInstance(CLSID_ShellLink, ByVal %NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, psl )) Then
      pp = @psl: Call Dword @pp Using Sub3( ByVal psl, IID_Persist, ppf ) To lResult
      TmpAsciiz = LinkPath
      MultiByteToWideChar %CP_ACP, 0, TmpAsciiz, %Max_Path, ByVal VarPtr(TmpWide), 2 * %Max_Path
      pp = @ppf + 20: Call Dword @pp Using Sub3( ByVal ppf, TmpWide, ByVal %TRUE )
      pp = @psl + 12: Call Dword @pp Using Sub5( ByVal psl, outvalue, ByVal %Max_Path, FileData, Flags )  'GetFilePath
      pp = @ppf + 8: Call Dword @pp Using Sub1( ByVal ppf )      'Release the persistant file
      pp = @psl + 8: Call Dword @pp Using Sub1( ByVal psl )      'Unbind the shell link object from the persistent file
      Function = outvalue
   End If
   CoUninitialize
End Function

Sub SetMenus
    If Debug Then cPrint LCase$(FuncName$)
    Menu Set State hPopupSettings, ByCmd %IDM_ZeroAlpha, ZeroAlpha * 8
    Menu Set State hPopupSettings, ByCmd %IDM_ResizeImage, ResizeImage * 8
    Menu Set State hPopupSettings, ByCmd %IDM_AutoScroll, AutoScroll * 8
    Menu Set State hPopupSettings, ByCmd %IDM_ColorFinder, ColorFinder * 8
    Menu Set State hPopupSettings, ByCmd %IDM_ThinGrid, ThinGrid * 8
    Menu Set State hPopupSettings, ByCmd %IDM_HexDisplay, HexDisplay * 8

    Menu Set State hPopupSize, ByCmd %IDM_Size5, 0
    Menu Set State hPopupSize, ByCmd %IDM_Size10, 0
    Menu Set State hPopupSize, ByCmd %IDM_Size25, 0
    Menu Set State hPopupSize, ByCmd %IDM_Size50, 0
    Menu Set State hPopupSize, ByCmd %IDM_Size100, 0
    Menu Set State hPopupSize, ByCmd %IDM_Size250, 0
    Menu Set State hPopupSize, ByCmd %IDM_SizeCustom, 0
    If CellSizeX = 5 And CellSizeY = 5 Then
        Menu Set State hPopupSize, ByCmd %IDM_Size5, 8
    ElseIf CellSizeX = 10 And CellSizeY = 10 Then
        Menu Set State hPopupSize, ByCmd %IDM_Size10, 8
    ElseIf CellSizeX = 25 And CellSizeY = 25 Then
        Menu Set State hPopupSize, ByCmd %IDM_Size25, 8
    ElseIf CellSizeX = 50 And CellSizeY = 50 Then
        Menu Set State hPopupSize, ByCmd %IDM_Size50, 8
    ElseIf CellSizeX = 100 And CellSizeY = 100 Then
        Menu Set State hPopupSize, ByCmd %IDM_Size100, 8
    ElseIf CellSizeX = 250 And CellSizeY = 250 Then
        Menu Set State hPopupSize, ByCmd %IDM_Size250, 8
    Else
        Menu Set State hPopupSize, ByCmd %IDM_SizeCustom, 8
    End If

    Menu Set State hPopupSettings, ByCmd %IDM_Debug, Debug * 8

    Menu Set Text hPopupSize, ByCmd %IDM_SizeCustom, "Custom  (" + Str$(CustomXCellSize) + "x" + Trim$(Str$(CustomYCellSize))+")"

End Sub

Sub SetCustomCellSize
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, x,y As Long
    CenterOverDialog(300,225,x,y)
    temp$ = InputBox$("Enter cell size as   x,y", "Custom Cell Size", Str$(CustomXCellSize) + "," + Str$(CustomYCellSize), x,y)
    If Len(temp$)=0 Then Exit Sub
    CustomXCellSize = Val(Parse$(temp$,",",1))
    CustomYCellSize = Val(Parse$(temp$,",",2))
    If CustomXCellSize < 1 Or CustomXCellSize > 10000 Then CustomXCellSize = 10
    If CustomYCellSize < 1 Or CustomYCellSize > 10000 Then CustomYCellSize = 10
    ChangeCellSize(CustomXCellSize,CustomYCellSize)
End Sub

Sub CycleCellSize
    If Debug Then cPrint LCase$(FuncName$)
    If CellSizeX = 5 And CellSizeY = 5 Then
        CellSizeX = 10 : CellSizeY = 10
    ElseIf CellSizeX = 10 And CellSizeY = 10 Then
        CellSizeX = 25 : CellSizeY = 25
    ElseIf CellSizeX = 25 And CellSizeY = 25 Then
        CellSizeX = 50  : CellSizeY = 50
    ElseIf CellSizeX = 50 And CellSizeY = 50 Then
        CellSizeX = 100  : CellSizeY = 100
    ElseIf CellSizeX = 100 And CellSizeY = 100 Then
        CellSizeX = 250  : CellSizeY = 250
    ElseIf CellSizeX = 250 And CellSizeY = 250 Then
        CellSizeX = CustomXCellSize  : CellSizeY = CustomYCellSize
    Else
        CellSizeX = 5 : CellSizeY = 5
    End If
    ChangeCellSize(CellSizeX,CellSizeY)
End Sub

Sub CPrint (SOut As String)
   Static cWritten, iCount As Long
   Local dx,dy As Long
   Dialog Get Loc hDlg To dx,dy
   If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
   sOut = Format$(iCount,"000000  ") + sOut
   WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
   Incr iCount
End Sub

Sub ClearConsole
   If Debug Then cPrint LCase$(FuncName$)
   Local hWrittenChars As Long
   Local tConsoleInfo As CONSOLE_SCREEN_BUFFER_INFO
   GetConsoleScreenBufferInfo(hConsole, tConsoleInfo)
   FillConsoleOutputCharacter(hConsole, 32, tConsoleInfo.dwSize.x * tConsoleInfo.dwSize.y, Mak(Dword,0,0), hWrittenChars)
   SetConsoleCursorPosition(hConsole, Mak(Dword,0,0))
   Sleep 500   'time for cursor to move off ListView
End Sub

Sub HighlightImage
   If Debug Then cPrint LCase$(FuncName$)
    Local iSelect,x1,y1,x2,y2 As Long, temp$
    ListView Get Select hDlg, %IDC_Listview To iSelect
    If DataType = %PixelData Then
        'draw circle around pixel
        ListView Get Text hDlg, %IDC_Listview, iSelect, 1 To temp$ : x1 = Val(temp$)
        ListView Get Text hDlg, %IDC_Listview, iSelect, 2 To temp$ : y1 = Val(temp$)
        Graphic Ellipse (x1-5,y1-5)-(x1+5,y1+5), %Red
    Else
        'draw circle around cell
        ListView Get Text hDlg, %IDC_Listview, iSelect, 7 To temp$  : x1 = Val(temp$)
        ListView Get Text hDlg, %IDC_Listview, iSelect, 8 To temp$  : y1 = Val(temp$)
        ListView Get Text hDlg, %IDC_Listview, iSelect, 9 To temp$  : x2 = Val(temp$)
        ListView Get Text hDlg, %IDC_Listview, iSelect, 10 To temp$ : y2 = Val(temp$)
        Graphic Box (x1,y1)-(x2,y2),, %Red
    End If
End Sub

Sub HighlightListView
    If Debug Then cPrint LCase$(FuncName$)
    Local iRow,x,y As Long, pt As Point
    GetCursorPos pt : ScreenToClient hGraphic, pt  'pt now has graphic client coordinates
    If DataType = %PixelData Then
       iRow = pt.y * imgW + pt.x     'row containing x,y
    Else
       'find cell containing
       x = pt.x \ CellSizeX
       y = pt.y \ CellSizeY
       iRow = y*XCellCount + x
    End If
    ListView Select hDlg, %IDC_ListView, iRow + 1
    ListView Visible hDlg, %IDC_Listview, iRow + 1
    Control Set Focus hDlg, %IDC_ListView
End Sub

Sub DisplayImage
   If Debug Then cPrint LCase$(FuncName$)
'   If ColorType = %PixelColor Then Graphic Copy hBmp, 0 Else DisplayCellColors  'display image
   If ColorType = %PixelColor Then Graphic Set Bits bmp$ Else DisplayCellColors  'display image
   MakeGrid
End Sub

Sub DisplayHeaders
   If Debug Then cPrint LCase$(FuncName$)
   SetListViewColumns(IIf(DataType = %PixelData, 0, 1))                          'ListView headers
End Sub

Sub ChangeCellSize(x As Long, y As Long)
   If Debug Then cPrint LCase$(FuncName$)
    CellSizeX = x : CellSizeY = y
    CreateCellData
    SetListViewRowCount
    DisplayImage
    SetMenus
    SetStatusBarText
End Sub

Sub SetListViewRowCount
    If Debug Then cPrint LCase$(FuncName$)
    If DataType = %PixelData Then
       ListView_SetItemCountEx(hListview, imgW*imgH,0)   ', %LVSICF_noInvalidateall)
    Else
       ListView_SetItemCountEx(hListview, XCellCount*YCellCount,0)  ', %LVSICF_noInvalidateall)
    End If
End Sub

Sub AddCFNToHistory
    If Debug Then cPrint LCase$(FuncName$)
    Menu Delete hPopupHistory, ByCmd %IDM_History1
    Menu Delete hPopupHistory, ByCmd %IDM_History2
    Menu Delete hPopupHistory, ByCmd %IDM_History3
    Menu Delete hPopupHistory, ByCmd %IDM_History4
    Menu Delete hPopupHistory, ByCmd %IDM_History5

    If CFN = History1 Then
        'nothing
    ElseIf CFN = History2 Then
        History2 = History1 : History1 = CFN
    ElseIf CFN = History3 Then
        History3 = History2 : History2 = History1 : History1 = CFN
    ElseIf CFN = History4 Then
        History4 = History3 : History3 = History2 : History2 = History1 : History1 = CFN
    Else
        History5 = History4 : History4 = History3 : History3 = History2 : History2 = History1 : History1 = CFN
    End If

    If Len(History1) Then Menu Add String, hPopupHistory, History1, %IDM_History1, %MF_Enabled
    If Len(History2) Then Menu Add String, hPopupHistory, History2, %IDM_History2, %MF_Enabled
    If Len(History3) Then Menu Add String, hPopupHistory, History3, %IDM_History3, %MF_Enabled
    If Len(History4) Then Menu Add String, hPopupHistory, History4, %IDM_History4, %MF_Enabled
    If Len(History5) Then Menu Add String, hPopupHistory, History5, %IDM_History5, %MF_Enabled
End Sub

Sub LoadNewFile
   If Debug Then cPrint LCase$(FuncName$)
   LoadCFN
   AddCFNToHistory
   If ZeroAlpha Then ZeroAlphaData
   Control Set Size hDlg, %IDC_Graphic, imgW, imgH
   gRect.nRight = gRect.nLeft + imgW : gRect.nBottom = gRect.nTop + imgH
   Graphic Attach hDlg, %IDC_Graphic
   Graphic Set Overlap
   CreatePixelData : CreateCellData
   SetListViewRowCount
   DisplayImage
   DisplayHeaders
   SetMenus
   SetToolbarButtonStatus
   SetStatusBarText
End Sub

Sub ROI
   If Debug Then cPrint LCase$(FuncName$)
   'MsgBox "ROI analysis not implemented!", %MB_Ok + %MB_IconInformation, "Region Of Interest"
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   MessageBox 0, "ROI analysis not implemented!", "Region Of Interest", %MB_IconInformation Or %MB_Ok Or %MB_TaskModal

End Sub

Sub DrawRect(Flag As Long)   '1=moving 0=done
   If Debug Then cPrint LCase$(FuncName$)
'   If (gR.nLeft = gR.nRight) And (gR.Top = gR.nBottom) Then Exit Sub

   Local i As Long, tempR As Rect
   Graphic Set Mix %Mix_NotXorSrc
   Graphic Style 1
   Graphic Box (gR2.nLeft,gR2.nTop)-(gR2.nRight,gR2.nBottom), 0, %Black
   tempR.nLeft = Min(gR.nLeft,gR.nRight)
   tempR.nRight = Max(gR.nLeft,gR.nRight)
   tempR.nTop = Min(gR.nTop,gR.nBottom)
   tempR.nBottom = Max(gR.nTop,gR.nBottom)
   If Flag Then
       Graphic Box (tempR.nLeft,tempR.nTop)-(tempR.nRight,tempR.nBottom), %Black
       gR2 = tempR
   Else
       Reset gR2
   End If
   Graphic Set Mix %Mix_CopySrc
   Graphic Style 0
End Sub

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y,iColor As Long, mpt As Point
   Select Case Msg
      Case %WM_ContextMenu
         If PreventContext = 0 Then
            x = Lo(Integer,LParam) : y = Hi(Integer, LParam)
            TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0
         End If
         If DrawInWork = 0 Then PreventContext = 0
      Case %WM_RButtonDown
          Reset gR
          DrawInWork = 0
          PreventContext = 0
          gR.nLeft = Lo(Word, LParam)   : gR.nTop  = Hi(Word, LParam)
          gR.nRight = gR.nLeft          : gr.nBottom = gR.nTop
      Case %WM_RButtonUp
          'no action
      Case %WM_MouseMove
          If (WParam And %MK_RBUTTON) Then
              gR.nRight  = Lo(Word, LParam) : gR.nBottom = Hi(Word, LParam)
              If (gR.nLeft <> gR.nRight) Or (gR.Top <> gR.nBottom) Then
                  DrawRect 0
                  DrawRect 1
                  DrawInWork = 1
                  PreventContext = 1
              End If
          ElseIf (WParam And %MK_LBUTTON) Then
              GetCursorPos mpt               'pt has xy screen coordinates
              ScreenToClient hDlg, mpt       'pt now has dialog client coordinates
              If PtInRect(gRect,mpt) Then
                  If ColorType = %PixelColor Then
                    Graphic Get Pixel (Lo(Word,lParam),Hi(Word,lParam)) To iColor
                    x = Lo(Word,lParam)
                    y = Hi(Word,lParam)
                    Statusbar Set Text hDlg, %IDC_StatusBar, 4, 0, " Pixel:  " + Str$(x) + "x" + Trim$(Str$(y)) + "  " + IIf$(HexDisplay,"&H" + Hex$(iColor),Str$(iColor))
                  Else
                    'find cell containing
                    x = Lo(Word,lParam) \ CellSizeX
                    y = Hi(Word,lParam) \ CellSizeY
                    Statusbar Set Text hDlg, %IDC_StatusBar, 4, 0, " Cell:  " + Str$(x) + "x" + Trim$(Str$(y))
                  End If
                  DrawZoomWindowContent x,y
              End If
          End If
      Case %WM_LButtonDown
          If AutoScroll Then HighlightListView
          SetFocus hGraphic
          SetCapture hGraphic
'          Reset gR,gR2
          DrawInWork = 0
      Case %WM_LButtonUp
          If AutoScroll Then HighlightListView
          ReleaseCapture
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub ConvertToGray
   If Debug Then cPrint LCase$(FuncName$)
   Local bp As Byte Pointer, i,iColor,B,G,R As Long, lp As Long Pointer
   bp = StrPtr(bmp$)+8         'starting position for pixel data in string
   lp = bp
   For i = 0 To ImgW*ImgH - 1
      B = 0.11 * @bp : Incr bp
      G = 0.59 * @bp : Incr bp
      R = 0.30 * @bp : Incr bp
      iColor = B+G+R
      Incr bp                  'no A histogram
      @lp = Bgr(iColor,iColor,iColor)
      Incr lp
   Next i
   Graphic Set Bits bmp$
   CreatePixelData : CreateCellData
   DisplayImage
End Sub

Sub FlipVertical
   If Debug Then cPrint LCase$(FuncName$)
   Local i,j As Long, lp,lp_orig,fp As Long Pointer   'fp = flip position pointer
   lp = StrPtr(bmp$)+8                'starting position for pixel data in string
   lp_orig = lp
   For i = 1 To imgW*(imgH\2)
      fp = lp_orig + (imgW*(imgH-(i\imgW)-1)+(i Mod imgW -1))*4
      Swap @fp, @lp
      Incr lp
   Next i
   Graphic Set Bits bmp$
   CreatePixelData : CreateCellData
   DisplayImage
End Sub


Sub FlipHorizontal
   If Debug Then cPrint LCase$(FuncName$)
   Local i,j As Long, lp,lp_orig,fp As Long Pointer   'fp = flip position pointer
   lp_orig = StrPtr(bmp$)+8         'starting position for pixel data in string
   For i = 1 To (imgW*imgH)*4 Step imgW*4
      lp = lp_orig + (i-1) : fp = lp + imgW*4 - 4  'reposition pointers
      For j = 1 To imgW\2
          Swap @fp, @lp
          Incr lp : Decr fp                        'move lp pointer up, fp pointer down
      Next j
   Next i
   Graphic Set Bits bmp$
   CreatePixelData : CreateCellData
   DisplayImage
End Sub

Sub CopyToClipboard
   If Debug Then cPrint LCase$(FuncName$)
   Local hTemp As Dword
   'copy selection to memory bitmap
   If (gR2.nRight = gR2.nLeft) Or (gR2.nTop = gR2.nBottom) Then
       'copy entire bitmap
       Clipboard Reset
       Clipboard Set Bitmap hGraphic
   Else
       'copy select
       Graphic Bitmap New gR2.nright-gR2.nleft+1, gR2.nbottom-gR2.ntop + 1 To hTemp
       Graphic Attach hTemp, 0
       Graphic Copy hDlg, %IDC_Graphic, (gR2.nleft+1,gR2.ntop+1)-(gR2.nright-1,gR2.nbottom-1) To (0,0)
       'copy to clipboard
       Clipboard Reset
       Clipboard Set Bitmap hTemp
       Graphic Bitmap End
   End If
   'restore %IDC_Graphic as default graphic target
   Graphic Attach hDlg, %IDC_Graphic
   Graphic Set Overlap
End Sub

Sub Restore
   If Debug Then cPrint LCase$(FuncName$)
   Graphic Attach hBMP, 0
   Graphic Get Bits To bmp$
   Graphic Attach hDlg, %IDC_Graphic
   Graphic Set Overlap
   Graphic Set Bits bmp$
   CreatePixelData : CreateCellData
   SetListViewRowCount
   DisplayImage
End Sub

Sub ClearHighlighting
   If Debug Then cPrint LCase$(FuncName$)
   DisplayImage
End Sub

Sub LoadFromClipboard
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$, iResult As Long, hClipboard As Dword
   temp$ = Exe.Path$ + "gbimagelab_temp.bmp"
   Clipboard Get Bitmap To hClipboard, iResult  'put image into memory bitmap
   If iResult Then
       Graphic Attach hClipboard,0
       Graphic Save temp$                           'save to file
       Graphic Bitmap End                           'no longer needed
       CFN = LCase$(temp$)                          'set CFN to that file
       LoadNewFile
   Else
'       MsgBox "No image found!" , %MB_Ok + %MB_IconExclamation, "Load Image From Clipboard"
        hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
        MessageBox 0, "No image found!", "Load Image From Clipboard", %MB_IconExclamation Or %MB_Ok Or %MB_TaskModal
   End If
End Sub

Sub Histogram
   If Debug Then cPrint LCase$(FuncName$)
   If IsWindow(hHistogram) Then Graphic Window End hHistogram : Exit Sub
   'create histogram from content of bmp$
   Local bp As Byte Pointer, i,pCount,Rmax,Gmax,Bmax,dx,dy As Long, sR,sG,sB As Single
   Dialog Get Loc hDlg To dx,dy
   Dim R(255) As Long, G(255) As Long, B(255) As Long
   pCount = imgW*imgH
   bp = StrPtr(bmp$)+8         'starting position for pixel data in string
   For i = 0 To ImgW*ImgH - 1
      Incr B(@bp) : Bmax = Max(Bmax,B(@bp)) : Incr bp
      Incr G(@bp) : Gmax = Max(Gmax,G(@bp)) : Incr bp
      Incr R(@bp) : Rmax = Max(Rmax,R(@bp)) : Incr bp
      Incr bp                  'no A histogram
   Next i
   'plot data
   Graphic Window "Histogram", dx+150,dy+125,300,450 To hHistogram
   Graphic Attach hHistogram,0
   Graphic Box (19,20)-(277,132),,%Black : Graphic Box (19,170)-(277,282),,%Black : Graphic Box (19,322)-(277,432),,%Black
   sR = 100 / Rmax : sG = 100 / Gmax : sB = 100 / Bmax
   For i = 0 To 255
       Graphic Line (20+i,130)-(20+i,130-sR*R(i)),%Red
       Graphic Line (20+i,280)-(20+i,280-sG*G(i)),%Green
       Graphic Line (20+i,430)-(20+i,430-sB*B(i)),%Blue
   Next i
   'return graphic focus to the graphic control
   Graphic Attach hDlg, %IDC_Graphic
End Sub

Sub Zoom
   If Debug Then cPrint LCase$(FuncName$)
   If IsWindow(hZoom) Then Graphic Window End hZoom : Exit Sub
   Local dx,dy As Long
   Dialog Get Loc hDlg To dx,dy
   'plot data
   Graphic Window "Zoom", dx-25,dy+125,522,522 To hZoom
   SetWindowPos(hZoom, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOSIZE + %SWP_NOMOVE + %SWP_SHOWWINDOW) ' API call
   DrawZoomWindowContent imgW/2,imgH/2   'defaults to upper left corner of drawing
End Sub

Sub DrawZoomWindowContent (xo As Long, yo As Long)
   If Debug Then cPrint LCase$(FuncName$)

   'Exit Sub under these conditions
   If ColorType = %CellColor Then Exit Sub
   If IsFalse(IsWindow(hZoom)) Then Exit Sub

   '20x20 color cells, 5 pixels on either side of the selected pixel

   Local x,y,x1,y1,wWide,hTall,iZoom As Long
   iZoom = 12 : wWide = 20 : hTall = 20
   Graphic Attach hZoom, 0, ReDraw
   Graphic Clear

   'draw colors
   For x = -iZoom To iZoom
       x1 = (x+iZoom)*wWide
       For y = -iZoom To iZoom
           y1 = (y+iZoom)*hTall
           Graphic Box (x1+10,y1+10)-(x1+10+wWide,y1+hTall+10),0,PixelData(xo+x,yo+y).color,PixelData(xo+x,yo+y).color
       Next y
   Next x

   'draw lines
   For x = 10 To 510 Step wWide
       Graphic Line (x,10)-(x,511),%Black
       Graphic Line (10,x)-(511,x),%Black
   Next x

   Graphic ReDraw
   Graphic Attach hDlg, %IDC_Graphic   'return to %IDC_Graphic as default graphic control
End Sub

Sub ShowConsole
   If Debug Then cPrint LCase$(FuncName$)
   Debug = Debug Xor 1
   If Debug Then
       cPrint "Console Display Enabled" + $CrLf + String$(30,"=")
   Else
       FreeConsole
       hConsole = 0
   End If
   SetMenus
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long    'MsgBox is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx hHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then cPrint LCase$(FuncName$)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub
